Imports System.IO

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExitSep As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents dlgOpenINI As System.Windows.Forms.OpenFileDialog
    Friend WithEvents txtXml As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem()
        Me.mnuFileExitSep = New System.Windows.Forms.MenuItem()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.dlgOpenINI = New System.Windows.Forms.OpenFileDialog()
        Me.txtXml = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileExitSep, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileExitSep
        '
        Me.mnuFileExitSep.Index = 1
        Me.mnuFileExitSep.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'dlgOpenINI
        '
        Me.dlgOpenINI.Filter = "INI Files (*.ini)|*.ini|All Files (*.*)|*.*"
        Me.dlgOpenINI.Title = "INI File"
        '
        'txtXml
        '
        Me.txtXml.Dock = System.Windows.Forms.DockStyle.Fill
        Me.txtXml.Multiline = True
        Me.txtXml.Name = "txtXml"
        Me.txtXml.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtXml.Size = New System.Drawing.Size(292, 273)
        Me.txtXml.TabIndex = 0
        Me.txtXml.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtXml})
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "INI2XML"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dlgOpenINI.InitialDirectory = Application.StartupPath
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' Open an INI file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        Dim file_name As String
        Dim xml_contents As String

        ' Let the user select the INI file.
        If dlgOpenINI.ShowDialog() = DialogResult.Cancel Then Exit Sub

        ' Load the INI file.
        file_name = dlgOpenINI.FileName

        ' Load the file and convert it into XML.
        xml_contents = IniToXml(GetFileContents(file_name))

        ' Save the results.
        file_name = file_name.Substring(0, file_name.Length - 3) & "xml"
        SetFileContents(file_name, xml_contents)

        ' Display the results.
        txtXml.Text = xml_contents
        txtXml.Select(0, 0)
    End Sub

    ' Convert the INI file into an XML file.
    Private Function IniToXml(ByVal ini_contents As String) As String
        Dim xml_contents As String
        Dim lines() As String
        Dim line_num As Integer
        Dim section_name As String
        Dim new_line As String
        Dim pos As Integer
        Dim item_name As String
        Dim item_value As String

        ' Break the INI file into lines.
        lines = Split(ini_contents, vbCrLf)

        ' Create the XML output.
        xml_contents = "<AllValues>" & vbCrLf
        For line_num = 0 To lines.GetUpperBound(0)
            ' Remove comments and trim the line.
            new_line = lines(line_num).Trim()
            pos = new_line.IndexOf(";")
            If pos >= 0 Then
                new_line = new_line.Substring(0, pos)
            End If
            new_line = new_line.Trim()

            ' See if this line begins a new section.
            If new_line.Length > 0 Then
                If new_line.Substring(0, 1) = "[" Then
                    ' This begins a new section.
                    ' Close the previous section.
                    If section_name <> "" Then
                        xml_contents &= "  </" & section_name & ">" & vbCrLf
                    End If

                    ' Save the new section name.
                    section_name = new_line.Substring(1, new_line.Length - 2)

                    ' Start the new XML section.
                    xml_contents &= "  <" & section_name & ">" & vbCrLf
                Else
                    ' This is a value. Find the =.
                    pos = new_line.IndexOf("=")
                    item_name = new_line.Substring(0, pos)
                    item_value = new_line.Substring(pos + 1)
                    xml_contents = xml_contents & _
                        "    <" & item_name & ">" & _
                        item_value & _
                        "</" & item_name & ">" & vbCrLf
                End If
            End If
        Next line_num

        ' Close the last section.
        If section_name <> "" Then
            xml_contents &= "  </" & section_name & ">" & vbCrLf
        End If

        ' End the XML document.
        xml_contents &= "</AllValues>" & vbCrLf

        ' Return the results.
        Return xml_contents
    End Function

    ' Return the file's contents in a string.
    Public Function GetFileContents(ByVal file_name As String) As String
        Dim stream_reader As New StreamReader(file_name)
        Dim text As String = stream_reader.ReadToEnd()

        stream_reader.Close()
        Return text
    End Function

    ' Write a file from a string.
    Public Sub SetFileContents(ByVal file_name As String, ByVal file_contents As String)
        Dim stream_writer As New StreamWriter(file_name)

        stream_writer.Write(file_contents)
        stream_writer.Close()
    End Sub
End Class
